## shadowsocksR-libev-2.5.6-2.tar.gz

=== libipset/CMakeLists.txt ===
# -*- coding: utf-8 -*-
# ----------------------------------------------------------------------
# Copyright © 2011-2013, RedJack, LLC.
# All rights reserved.
#
# Please see the LICENSE.txt file in this distribution for license
# details.
# ----------------------------------------------------------------------

cmake_minimum_required(VERSION 2.6)
set(PROJECT_NAME ipset)
set(RELEASE_DATE 2013-12-11)
project(${PROJECT_NAME})

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
find_package(CTargets)

#-----------------------------------------------------------------------
# Retrieve the current version number

#-----------------------------------------------------------------------
# Check for building on Tilera
# If the Tilera environment is installed, then $TILERA_ROOT is defined
# as the path to the active MDE.

if(DEFINED ENV{TILERA_ROOT})
    set(TILERA TRUE)
    set(TILERA_ROOT $ENV{TILERA_ROOT})
    message("-- Configuring for Tilera MDE ${TILERA_ROOT}")
    set(ENV{PKG_CONFIG_PATH}
        "${TILERA_ROOT}/tile/usr/lib/pkgconfig:${TILERA_ROOT}/tile/usr/local/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}"
    )
    set(CMAKE_SYSTEM_NAME "Tilera")
    set(CMAKE_SYSTEM_PROCESSOR "tilegx")
    set(CMAKE_C_COMPILER "${TILERA_ROOT}/bin/tile-gcc")
    set(CMAKE_LINKER "${TILERA_ROOT}/bin/tile-ld")
    set(TILERA_MONITOR "${TILERA_ROOT}/bin/tile-monitor")
    #add_definitions(-std=gnu99)
    set(CMAKE_FIND_ROOT_PATH "${TILERA_ROOT}/tile")
    set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
    set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
    set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)
endif()

#-----------------------------------------------------------------------
# Check for prerequisite libraries

include_directories(${libcork_include_dirs})

#-----------------------------------------------------------------------
# Set some options

if(APPLE)
    if (NOT CMAKE_INSTALL_NAME_DIR)
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
    endif (NOT CMAKE_INSTALL_NAME_DIR)
endif(APPLE)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
    add_definitions(-Wall -Werror)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
    add_definitions(-Wall -Werror)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Intel")
    add_definitions(-Wall -Werror)
endif(CMAKE_C_COMPILER_ID STREQUAL "GNU")

#-----------------------------------------------------------------------
# Include our subdirectories

#add_subdirectory(src)

add_c_library(
        libipset
        OUTPUT_NAME ipset
        PKGCONFIG_NAME libipset
        VERSION 1.1.0
        SOURCES
        general.c
        bdd/assignments.c
        bdd/basics.c
        bdd/bdd-iterator.c
        bdd/expanded.c
        bdd/reachable.c
        bdd/read.c
        bdd/write.c
        map/allocation.c
        map/inspection.c
        map/ipv4_map.c
        map/ipv6_map.c
        map/storage.c
        set/allocation.c
        set/inspection.c
        set/ipv4_set.c
        set/ipv6_set.c
        set/iterator.c
        set/storage.c

        LOCAL_LIBRARIES
        libcork
)

set(libipset_include_dirs
        ${PROJECT_SOURCE_DIR}/include
        ${PROJECT_BINARY_DIR}/include
        CACHE INTERNAL "libipset library" FORCE
        )

=== src/CMakeLists.txt ===
set(SOURCE_FILES_SNI
        http.c
        tls.c
        rule.c)

set(SOURCE_FILES_LOCAL
        utils.c
        jconf.c
        json.c
        encrypt.c
        udprelay.c
        cache.c
        acl.c
        netutils.c
        local.c
        ${SOURCE_FILES_SNI})

set(SOURCE_FILES_TUNNEL
        utils.c
        jconf.c
        json.c
        encrypt.c
        udprelay.c
        cache.c
        netutils.c
        tunnel.c)

set(SOURCE_FILES_SERVER
        utils.c
        jconf.c
        json.c
        encrypt.c
        udprelay.c
        cache.c
        acl.c
        resolv.c
        netutils.c
        server.c
        ${SOURCE_FILES_SNI})

set(SOURCE_FILES_MANAGER
        utils.c
        jconf.c
        json.c
        manager.c)

set(SOURCE_FILES_REDIR
        utils.c
        jconf.c
        json.c
        encrypt.c
        netutils.c
        cache.c
        udprelay.c
        redir.c
        ${SOURCE_FILES_SNI})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${libev_include_dirs})
include_directories(${libcork_include_dirs})
include_directories(${libipset_include_dirs})
include_directories(${libudns_include_dirs})
include_directories(${libsodium_include_dirs})


if (WIN32)
    list ( APPEND SOURCE_FILES_LOCAL win32.c )
    list ( APPEND SOURCE_FILES_TUNNEL win32.c )
    list ( APPEND SOURCE_FILES_SERVER win32.c )
endif ()

add_executable(ss_local ${SOURCE_FILES_LOCAL})
#add_executable(ss_tunnel ${SOURCE_FILES_TUNNEL})
#add_executable(ss_server ${SOURCE_FILES_SERVER})
#add_executable(ss_manager ${SOURCE_FILES_MANAGER})
add_executable(ss_redir ${SOURCE_FILES_REDIR})
add_library(libshadowsocks-libev ${SOURCE_FILES_LOCAL})

set_target_properties(ss_local PROPERTIES
        COMPILE_DEFINITIONS MODULE_LOCAL
        )
#set_target_properties(ss_tunnel PROPERTIES
#        COMPILE_DEFINITIONS MODULE_TUNNEL
#        )
#set_target_properties(ss_server PROPERTIES
#        COMPILE_DEFINITIONS MODULE_REMOTE
#        )
#set_target_properties(ss_manager PROPERTIES
#        COMPILE_DEFINITIONS MODULE_MANAGER
#        )
set_target_properties(ss_redir PROPERTIES
        COMPILE_DEFINITIONS MODULE_REDIR
        )
target_compile_definitions(libshadowsocks-libev
        PRIVATE MODULE_LOCAL LIB_ONLY
        )
set_target_properties(libshadowsocks-libev PROPERTIES SUFFIX ".la")

set (ss_lib_common
        ev
        m
        libcork)

set (ss_lib_net
        ${ss_lib_common}
        ${LIBCRYPTO}
        libipset
        ${PCRE_LIBRARIES}
        udns
        sodium
        )

if (WIN32)
    list ( APPEND ss_lib_net Ws2_32 )
endif()

target_link_libraries(ss_local
        ${ss_lib_net}
)
#target_link_libraries(ss_tunnel
#        ${ss_lib_net}
#        )
#target_link_libraries(ss_server
#        ${ss_lib_net}
#        )
#target_link_libraries(ss_manager
#        ${ss_lib_common}
#        )
target_link_libraries(ss_redir
        ${ss_lib_net}
        )

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: extra
Maintainer: Max Lv <max.c.lv@gmail.com>
Build-Depends:
 asciidoc,
 autotools-dev,
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 gawk,
 libpcre3-dev,
 libssl-dev (>= 0.9.8),
 mime-support,
 pkg-config,
 xmlto,
Standards-Version: 3.9.8
Homepage: https://www.shadowsocks.org
Vcs-Git: https://github.com/shadowsocks/shadowsocks-libev.git
Vcs-Browser: https://github.com/shadowsocks/shadowsocks-libev

Package: libshadowsocks-libev-dev
Architecture: any
Section: libdevel
Breaks:
 shadowsocks-libev (<< 2.4.0),
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends},
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces: libshadowsocks-libev1
Breaks:
 libshadowsocks-libev1,
 shadowsocks-libev (<< 2.4.0),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides shared libraries.

Package: shadowsocks-libev
Replaces:
 shadowsocks (<< 1.5.3-2),
Breaks:
 shadowsocks (<< 1.5.3-2),
Architecture: any
Depends:
 apg,
 ${misc:Depends},
 ${shlibs:Depends},
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
